var map; 
var geolocation;
var broutePolicy = [BMAP_TRANSIT_POLICY_LEAST_TIME,BMAP_TRANSIT_POLICY_LEAST_TRANSFER,BMAP_TRANSIT_POLICY_LEAST_WALKING,BMAP_TRANSIT_POLICY_AVOID_SUBWAYS];

var OWNMAP = {
	//加载地图页面
	load_map : function(containId){
		if(mapType == 1){    
			//百度
			map = new BMap.Map(containId);
			map.centerAndZoom(cityname,15);
			map.enableScrollWheelZoom(true);
			geolocation = new BMap.Geolocation();
		}else if(mapType == 2){
		    //加载地图，调用浏览器定位服务
		    map = new AMap.Map(containId, {
		        resizeEnable: true
		    });
		    map.setCity(cityname);
		    map.plugin('AMap.Geolocation', function() {
		        geolocation = new AMap.Geolocation({
		            enableHighAccuracy: true,//是否使用高精度定位，默认:true
		            timeout: 10000,          //超过10秒后停止定位，默认：无穷大
		            buttonOffset: new AMap.Pixel(10, 20),//定位按钮与设置的停靠位置的偏移量，默认：Pixel(10, 20)
		            zoomToAccuracy: true,      //定位成功后调整地图视野范围使定位位置及精度范围视野内可见，默认：false
		            buttonPosition:'RB'
		        });
		        map.addControl(geolocation);
		    });
		}
	},
	
	search_info : function(keyword,type,callback){
		var results;
		if(mapType == 1){
			var map = new BMap.Map("l-map");     
			map.centerAndZoom(cityname, 15);
			var options = {
				onSearchComplete: function(result){
					// 判断状态是否正确
					if (local.getStatus() == BMAP_STATUS_SUCCESS){
						var results = [];
			            for (var i = 0; i < result.getCurrentNumPois(); i ++) {
			                var j = {};
			                j.name = result.getPoi(i).title;
			                j.address = result.getPoi(i).address;
			                j.lng = result.getPoi(i).point.lng;
			                j.lat = result.getPoi(i).point.lat;
			                results.push(j);
			            }
//			            JSON.stringify(results);
						callback(results,type);
					}
				}
			};
			var local = new BMap.LocalSearch(map, options);
			local.search(cityname+keyword);
			
		}else if(mapType == 2){
			AMap.service(["AMap.PlaceSearch"], function() {
		        var placeSearch = new AMap.PlaceSearch({ //构造地点查询类
		            city: cityname, //城市
		        });
		        //关键字查询
		        placeSearch.search(cityname+keyword, function(status, result) {
		        	if(status == 'complete' && result.info === 'OK'){
		        		var results = [];
		        		var count = 10;
		        		if(result.poiList.count > 10){
		        			count = 10;
		        		}else{
		        			count = result.poiList.count; 
		        		}
			            for (var i = 0; i < count; i ++) {
			                var j = {};
			                j.name = result.poiList.pois[i].name;
			                j.address = result.poiList.pois[i].address;
			                j.lng = result.poiList.pois[i].location.lng;
			                j.lat = result.poiList.pois[i].location.lat;
			                results.push(j);
			            }
			            //			            JSON.stringify(results);
		        		callback(results,type);
		        	}
		           
		        });
	    	});	
		}
	    
	},

	add_marker : function(map,lng,lat,imgurl,picWidth,picHeight,moveWidth,moveHeight){
		if(mapType == 1){
			var pos = changeGPS(lat,lng);
			var pt = new BMap.Point(pos.lon,pos.lat);
			var myIcon = new BMap.Icon(imgurl, new BMap.Size(picWidth,picHeight),{imageSize:new BMap.Size(picWidth, picHeight)},{anchor: new BMap.Size(moveWidth, moveHeight)},
			{imageOffset: new BMap.Size(0, 0)});
			var marker = new BMap.Marker(pt,{icon:myIcon});
			map.addOverlay(marker);
			return marker;
		}else if(mapType == 2){
			var pos = GPS.gcj_encrypt(lat,lng);
        	var marker = new AMap.Marker({
	        map: map,
			position: [pos.lon,pos.lat],
	        icon: new AMap.Icon({            
	            size: new AMap.Size(picWidth,picHeight+10),  //图标大小
	            imageSize: new AMap.Size(picWidth,picHeight),
	            image: imgurl,
	            imageOffset: new AMap.Pixel(0,10),
	        	}),
	    	});
	    	return marker;
		}
		
	},
	
	add_lable : function(marker,content,moveWidth,moveHeight){
		if(mapType == 1){
			var label = new BMap.Label(content,{offset:new BMap.Size(moveWidth,moveHeight)});
			label.setStyle({ 
				color : "#FFFF00", 
				fontSize : "6px", 
				backgroundColor :"0.5",
				border :"0", 
			});
			marker.setLabel(label);
		}else if(mapType == 2){
		  	marker.setLabel({
		      	offset: new AMap.Pixel(moveWidth, moveHeight),
		      	content: content
		  	});
		}
	},
	
	
	load_rount_location : function(startlng,startlat,endlng,endlat,mapId,resultId,policyId){
		if(mapType == 1){
			map = new BMap.Map(mapId);
			var point = new BMap.Point(longitude, latitude);
			map.centerAndZoom(point,15);
			map.enableScrollWheelZoom(true);
			var p1 = new BMap.Point(startlng,startlat);
			var p2 = new BMap.Point(endlng,endlat);
		    var transit = new BMap.TransitRoute(map, {
				renderOptions: {map: map, panel: resultId},
				policy: 0,
				onResultsHtmlSet : function(){$("#"+resultId+"").show()}
		    });
		    transit.setPolicy(broutePolicy[policyId]);
		    transit.setLocation(cityname);
		    transit.search(p1,p2);
		}else if(mapType == 2){
			var ap0 = AMap.TransferPolicy.LEAST_TIME;
			var ap1 = AMap.TransferPolicy.LEAST_TRANSFER;
			var ap2 = AMap.TransferPolicy.LEAST_WALK;
			var ap3 = AMap.TransferPolicy.NO_SUBWAY;
			var policy;
			if(policyId == 0) policy = ap0;
			if(policyId == 1) policy = ap1;
			if(policyId == 2) policy = ap2;
			if(policyId == 3) policy = ap3;
			map = new AMap.Map(mapId, {
		        resizeEnable: true,
		        zoom:15
		    });
		    map.setCity(cityname);
		    var transOptions = {
		        map: map,
		        city: cityname,
		        panel: resultId,                            
		        //cityd:'乌鲁木齐',
		        policy: policy
		    };
		    $("#"+resultId+"").empty();
		    //构造公交换乘类
		    var transfer = new AMap.Transfer(transOptions);
		    //根据起、终点坐标查询公交换乘路线
		    transfer.search(new AMap.LngLat(startlng,startlat), new AMap.LngLat(endlng, endlat),function(status){
		    	if(status == 'complete'){
		    		$("#"+resultId+"").show();
		    	}
		    });
		}
	},
	
	load_rount_adress : function(startInfo,endInfo,mapId,resultId,policyId){
		if(mapType == 1){
			map = new BMap.Map(mapId);
			var point = new BMap.Point(longitude, latitude);
			map.centerAndZoom(point,15);
			map.enableScrollWheelZoom(true);
		    var start = startInfo ,end = endInfo;
		    var transit = new BMap.TransitRoute(map, {
				renderOptions: {map: map, panel: resultId},
				policy: 0,
				onResultsHtmlSet : function(){$("#"+resultId+"").show()},
		    });
		    transit.setPolicy(broutePolicy[policyId]);
		    transit.setLocation(cityname);
		    transit.search(start,end);	
		}else if(mapType == 2){
			var ap0 = AMap.TransferPolicy.LEAST_TIME;
			var ap1 = AMap.TransferPolicy.LEAST_TRANSFER;
			var ap2 = AMap.TransferPolicy.LEAST_WALK;
			var ap3 = AMap.TransferPolicy.NO_SUBWAY;
			var policy;
			if(policyId == 0) policy = ap0;
			if(policyId == 1) policy = ap1;
			if(policyId == 2) policy = ap2;
			if(policyId == 3) policy = ap3;
			map = new AMap.Map(mapId, {
		        resizeEnable: true,
		        zoom:15
		    });
		    map.setCity(cityname);
		    var transOptions = {
		        map: map,
		        city: cityname,
		        panel: resultId,                            
		        //cityd:'乌鲁木齐',
		        policy: policy
		    };
		    $("#"+resultId+"").empty();
		    //构造公交换乘类
		    var transfer = new AMap.Transfer(transOptions);
		    transfer.search([
             {keyword: startInfo},
             {keyword: endInfo}
            ],function(status){
		    	if(status == 'complete'){
		    		$("#"+resultId+"").show();
		    	}
            });
		}
	},
	
	load_bus_line : function(containId,lname,busstart){
		var busName = cityname+lname+'路';
		if(mapType == 1){
			map = new BMap.Map(containId);
			map.centerAndZoom(cityname,15);
			map.enableScrollWheelZoom(true);
			var startIcon = new BMap.Icon("../../img/hc/qidian.png", new BMap.Size(26, 26),{imageSize:new BMap.Size(26, 26)},{anchor: new BMap.Size(13, 26)}, {    //小车图片
				imageOffset: new BMap.Size(0, 0)    //图片的偏移量。为了是图片底部中心对准坐标点。
			});
			var endIcon = new BMap.Icon("../../img/hc/zhongdian.png", new BMap.Size(26, 26),{imageSize:new BMap.Size(26, 26)},{anchor: new BMap.Size(13, 26)}, {    //小车图片
				imageOffset: new BMap.Size(0, 0)    //图片的偏移量。为了是图片底部中心对准坐标点。
			});
			var busline = new BMap.BusLineSearch(map,{
				renderOptions:{map:map},
				onGetBusListComplete: function(result){
				   if(result) {
					 var fstLine = result.getBusListItem(0);//获取第一个公交列表显示到map上
					 busline.getBusLine(fstLine);
				   }
				},
				onMarkersSet : function(mks){
					  
					if(mks){
						if(busstart == mks[0].AB){
							mks[0].setIcon(startIcon);
							mks[mks.length-1].setIcon(endIcon);
						}else{
							mks[0].setIcon(endIcon);
							mks[mks.length-1].setIcon(startIcon);
						}
					}
				}
			});
			busline.getBusList(busName);
		}else if(mapType == 2){
			map = new AMap.Map(containId, {
		        resizeEnable: true,
		        zoom: 15 //地图显示的缩放级别
		    });
		   	map.setCity(cityname);
		    /*公交线路查询*/
		    function lineSearch() {
		        //实例化公交线路查询类，只取回一条路线
		        var linesearch = new AMap.LineSearch({
		            pageIndex: 1,
		            city: dcity,
		            pageSize: 1,
		            extensions: 'all'
		        });
		        //搜索“536”相关公交线路
		        linesearch.search(busName, function(status, result) {
		            if (status === 'complete' && result.info === 'OK') {
		                lineSearch_Callback(result);
		            } else {
		                alert(result);
		            }
		        });
		    }
		    /*公交路线查询服务返回数据解析概况*/
		    function lineSearch_Callback(data) {
		        var lineArr = data.lineInfo;
		        var lineNum = data.lineInfo.length;
		        if (lineNum == 0) {
		        } else {
		            for (var i = 0; i < lineNum; i++) {
		            	var start = lineArr[i].start_stop;
		                var pathArr = lineArr[i].path;
		                var stops = lineArr[i].via_stops;
		                if(start == busstart){
		                	var startPot = stops[0].location;
		                	var endPot = stops[stops.length - 1].location;	
		                }else{
		                	var startPot = stops[stops.length - 1].location;
		                	var endPot = stops[0].location;
		                }
		                if (i == 0) drawbusLine(startPot, endPot, pathArr);
		            }
		        }
		    }
		    /*绘制路线*/
		    function drawbusLine(startPot, endPot, BusArr) {
		        //绘制起点，终点
		        new AMap.Marker({
		            map: map,
		            position: [startPot.lng, startPot.lat], //基点位置
		            icon: "http://webapi.amap.com/theme/v1.3/markers/n/start.png",
		            zIndex: 10
		        });
		        new AMap.Marker({
		            map: map,
		            position: [endPot.lng, endPot.lat], //基点位置
		            icon: "http://webapi.amap.com/theme/v1.3/markers/n/end.png",
		            zIndex: 10
		        });
		        //绘制乘车的路线
		        busPolyline = new AMap.Polyline({
		            map: map,
		            path: BusArr,
		            strokeColor: "#09f",//线颜色
		            strokeOpacity: 0.8,//线透明度
		            strokeWeight: 6//线宽
		        });
		        map.setFitView();
		    }
		    lineSearch();			
		}
	},
	
	remove_marker : function(markers){
		if(mapType == 1){
			for(var i=0;i<markers.length;i++){
				map.removeOverlay(markers[i]);
			}
		}else if(mapType == 2){
			map.remove(markers);
		}
	},

};